; rev 19 mars 
; modif tempo 
; was xtal/2000000 -> xtal / 100000
; rev 18 mars 2016
; MPLAB IDE version 8.92.00
; Configure bit set in the code !
; modif IdTypePIC code
; parametrage inclus dans ce code  SANS fichier externes *.inc
; Q=10MHz (platine 16F877 !) 
; 19200 bauds

;03/03/2012  
; MPLAB IDE version 8.63 





    TITLE "Bootloader pour PIC18F4685  40pins"
	radix DEC
	ERRORLEVEL -302
	ERRORLEVEL -230

 	 LIST  P=18F4685; change also: Configure->SelectDevice from Mplab
xtal EQU 10000000	; 10Mhz  you may want to change: _XT_OSC_1H  _HS_OSC_1H  _HSPLL_OSC_1H
baud EQU 19200		; the desired baud rate


	;	Tiny Bootloader		18F series		Size=100words
	;	claudiu.chiculita@ugal.ro
	;	http://www.etc.ugal.ro/cchiculita/software/picbootloader.htm

		#include "p18f4685.inc"
		#define max_flash 0x18000
IdTypePIC = 0x57      ;  was 0x2F ???

	
;========================================================================
;	#include "spbrgselect.inc"	; RoundResult and baud_rate
RoundResult SET 0				; Rounding function.  RoundResult = Round(aa/bb)
Round	macro aa,bb
	LOCAL rr = aa/bb
	LOCAL d1 = aa - rr*bb
	LOCAL d2 = (rr+1)*bb - aa
RoundResult = rr
	if d1 >= d2
RoundResult++
	endif
	endm

AbsResult SET 0
Abs		macro nr
	if nr>=0
AbsResult = nr
	else
AbsResult = -nr
	endif
	endm

	Round xtal,(16*baud)
spbrg_value EQU RoundResult-1

	Round xtal,(16*(spbrg_value+1))
baud_real EQU RoundResult
	Abs(baud_real-baud)
errpercent EQU AbsResult*100/baud
	if errpercent > 4
		ERROR big error in baudrate: #v(errpercent)%
	endif
	if errpercent >= 2
		messg baudrate not exact: #v(errpercent)%
	endif
	 space 1
	 messg choix SPBRG = #v(spbrg_value)
	 messg Vitesse en bauds = #v(baud_real)
	 messg baudrate erreur = #v(errpercent)
	 space 1
;==================================================================================

	#define first_address max_flash-200		;100 words
MF EQU max_flash-200
	messg  address depart bootloader  :  #v(MF)

;Config dans le projet
;voir 18F4685_Config_bits.txt

	__CONFIG _CONFIG1H, _OSC_HS_1H & _FCMEN_OFF_1H & _IESO_OFF_1H
	__CONFIG _CONFIG2L, _PWRT_ON_2L & _BOREN_OFF_2L
	__CONFIG _CONFIG2H, _WDT_OFF_2H & _WDTPS_1_2H
	__CONFIG _CONFIG3H, _MCLRE_ON_3H & _PBADEN_OFF_3H & _MCLRE_ON_3H
	__CONFIG _CONFIG4L, _DEBUG_OFF_4L & _LVP_OFF_4L & _STVREN_OFF_4L & _XINST_OFF_4L & _BBSIZ_1024_4L  
	__CONFIG _CONFIG5L, _CP0_OFF_5L & _CP1_OFF_5L & _CP2_OFF_5L
	__CONFIG _CONFIG5H, _CPB_OFF_5H
	__CONFIG _CONFIG6L, _WRT0_OFF_6L & _WRT1_OFF_6L & _WRT2_OFF_6L
	__CONFIG _CONFIG6H, _WRTB_OFF_6H & _WRTC_OFF_6H
	__CONFIG _CONFIG7L, _EBTR0_OFF_7L & _EBTR1_OFF_7L & _EBTR2_OFF_7L
	__CONFIG _CONFIG7H, _EBTRB_OFF_7H & _DEVID1 & _IDLOC0
;
;300001  02
;300002  18
;300003  1E
;300005  80
;300006  84
;300008  3F
;300009  C0
;30000A  3F
;30000B  E0
;30000C  3F
;30000D  40
;


;----------------------------- PROGRAM ---------------------------------
	cblock 0
	crc
	i
	cnt1
	cnt2
	cnt3
	counter_hi
	counter_lo
	flag
	endc
	cblock 10
	buffer:64
	endc

SendL macro car
	movlw car
	movwf TXREG
	endm

;------------ RESET -----------------------

		ORG     0x0000
		GOTO    Point_Entree_Bootloader

;view with TabSize=4
;-------   START    ----------------------
;-------  Bootloader  --------------------
;PC_flash:		C1h		U		H		L		x  ...  <64 bytes>   ...  crc
;PC_eeprom:		C1h		40h   EEADR   EEDATA	0		crc
;PC_cfg		C1h		U OR 80h	H		L		1		byte	crc
;PIC_response:	type `K`

	ORG first_address		;space to deposit first 4 instr. of user prog.
	nop
	nop
	nop
	nop
	org first_address+8
Point_Entree_Bootloader

	;init serial port
	movlw b'00100100'
	movwf TXSTA
	movlw spbrg_value
	movwf SPBRG
	movlw b'10010000'
	movwf RCSTA
							;wait for computer
	rcall Receive
	sublw 0xC1				;Expect C1h
	bnz way_to_exit
	SendL IdTypePIC			;send PIC type
MainLoop
	SendL 'K'				; "-Everything OK, ready and waiting."
mainl
	clrf crc
	rcall Receive			;Upper
	movwf TBLPTRU
	movwf flag			;(for EEPROM and CFG cases)
	rcall Receive			;Hi
	movwf TBLPTRH
	movwf EEADR			;(for EEPROM case)
	rcall Receive			;Lo
	movwf TBLPTRL
	movwf EEDATA		;(for EEPROM case)

	rcall Receive			;count
	movwf i
	incf i
	lfsr FSR0, (buffer-1)
rcvoct						;read 64+1 bytes
	movwf TABLAT		;prepare for cfg; => store byte before crc
	rcall Receive
	movwf PREINC0
	decfsz i
	bra rcvoct

	tstfsz crc				;check crc
	bra ziieroare
	btfss flag,6		;is EEPROM data?
	bra noeeprom
	movlw b'00000100'	;Setup eeprom
	rcall Write
	bra waitwre
noeeprom
	btfss flag,7		;is CFG data?
	bra noconfig
	tblwt*				;write TABLAT(byte before crc) to TBLPTR***
	movlw b'11000100'	;Setup cfg
	rcall Write
	bra waitwre
noconfig
							;write
eraseloop
	movlw	b'10010100'		; Setup erase
	rcall Write
	TBLRD*-					; point to adr-1

writebigloop
	movlw 8					; 8groups
	movwf counter_hi
	lfsr FSR0,buffer
writesloop
	movlw 8					; 8bytes = 4instr
	movwf counter_lo
writebyte
	movf POSTINC0,w			; put 1 byte
	movwf TABLAT
	tblwt+*
	decfsz counter_lo
	bra writebyte

	movlw	b'10000100'		; Setup writes
	rcall Write
	decfsz counter_hi
	bra writesloop
waitwre
	;btfsc EECON1,WR		;for eeprom writes (wait to finish write)
	;bra waitwre			;no need: round trip time with PC bigger than 4ms

	bcf EECON1,WREN			;disable writes
	bra MainLoop

ziieroare					;CRC failed
	SendL 'N'
	bra mainl

;******** procedures ******************

Write
	movwf EECON1
	movlw 0x55
	movwf EECON2
	movlw 0xAA
	movwf EECON2
	bsf EECON1,WR			;WRITE
	nop
	;nop
	return


Receive
	movlw xtal/1000000+1	; 19/03/2016 modif pour 10Mhz was for 20MHz 
	movwf cnt1
rpt2
	clrf cnt2
rpt3
	clrf cnt3
rptc
	btfss PIR1,RCIF			;test RX
	bra notrcv
	movf RCREG,w			;return read data in W
	addwf crc,f				;compute crc
	return
notrcv
	decfsz cnt3
	bra rptc
	decfsz cnt2
	bra rpt3
	decfsz cnt1
	bra rpt2
	;timeout:
way_to_exit
	bcf	RCSTA,	SPEN			; deactivate UART
	bra first_address



	 org  0xF00000  
EEPROM equ $
	messg Start eeprom = #V(EEPROM)

	; ATTENTION il faut que les messages soient de taille modulo 16
	;   1234567890123456
EE0	db "Bootload. 10Mhz",0
EE1	db "paulfjujo.free.",0
EE2	db "MPALAB v8.92   ",0
EE3 db " 19/03/2016    ",0
;EE4 dt "12345678901"   <- 11 cars
finEEprom	EQU $
ResteEE equ (.1024-(finEEprom-EEPROM))
	messg Reste en eeprom = #V(ResteEE)	cars	
	
;*************************************************************
; After reset
; Do not expect the memory to be zero,
; Do not expect registers to be initialised like in catalog.
            END
----------------------------------------------------------------------
----------------------------------------------------------------------
Release build of project `C:\Mplab8\_Mesprojets_ASM\_BOOTLOADERs\Bootloader_18F4685_10Mhz_19200.mcp' started.
Language tool versions: MPASMWIN.exe v5.51, mplink.exe v4.49, mplib.exe v4.49
Sat Mar 19 12:25:29 2016
----------------------------------------------------------------------
Clean: Deleting intermediary and output files.
Clean: Deleted file "C:\Mplab8\_Mesprojets_ASM\_BOOTLOADERs\tinybld_18F4685_10Mhz_19200bds.o".
Clean: Deleted file "C:\Mplab8\_Mesprojets_ASM\_BOOTLOADERs\tinybld_18F4685_10Mhz_19200bds.err".
Clean: Deleted file "C:\Mplab8\_Mesprojets_ASM\_BOOTLOADERs\tinybld_18F4685_10Mhz_19200bds.hex".
Clean: Deleted file "C:\Mplab8\_Mesprojets_ASM\_BOOTLOADERs\tinybld_18F4685_10Mhz_19200bds.lst".
Clean: Deleted file "C:\Mplab8\_Mesprojets_ASM\tinybld_18F4685_10Mhz_19200bds.cof".
Clean: Deleted file "C:\Mplab8\_Mesprojets_ASM\tinybld_18F4685_10Mhz_19200bds.map".
Clean: Done.
Executing: "C:\Program Files (x86)\Microchip\MPASM Suite\MPASMWIN.exe" /q /p18F4685 "tinybld_18F4685_10Mhz_19200bds.asm" /l"tinybld_18F4685_10Mhz_19200bds.lst" /e"tinybld_18F4685_10Mhz_19200bds.err"
Message[301] C:\MPLAB8\_MESPROJETS_ASM\_BOOTLOADERS\TINYBLD_18F4685_10MHZ_19200BDS.ASM 74 : MESSAGE: (choix SPBRG = 32)
Message[301] C:\MPLAB8\_MESPROJETS_ASM\_BOOTLOADERS\TINYBLD_18F4685_10MHZ_19200BDS.ASM 75 : MESSAGE: (Vitesse en bauds = 18939)
Message[301] C:\MPLAB8\_MESPROJETS_ASM\_BOOTLOADERS\TINYBLD_18F4685_10MHZ_19200BDS.ASM 76 : MESSAGE: (baudrate erreur = 1)
Message[301] C:\MPLAB8\_MESPROJETS_ASM\_BOOTLOADERS\TINYBLD_18F4685_10MHZ_19200BDS.ASM 82 : MESSAGE: (address depart bootloader  :  98104)
Message[301] C:\MPLAB8\_MESPROJETS_ASM\_BOOTLOADERS\TINYBLD_18F4685_10MHZ_19200BDS.ASM 284 : MESSAGE: (Start eeprom = 15728640)
Message[301] C:\MPLAB8\_MESPROJETS_ASM\_BOOTLOADERS\TINYBLD_18F4685_10MHZ_19200BDS.ASM 295 : MESSAGE: (Reste en eeprom = 960     cars)
Executing: "C:\Program Files (x86)\Microchip\MPASM Suite\mplink.exe" /p18F4685 /l"C:\Program Files\Microchip\MPASM Suite" /k"C:\Program Files (x86)\Microchip\MPASM Suite\LKR" "tinybld_18F4685_10Mhz_19200bds.o" /z__MPLAB_BUILD=1 /m"C:\Mplab8\_Mesprojets_ASM\tinybld_18F4685_10Mhz_19200bds.map" /w /o"C:\Mplab8\_Mesprojets_ASM\tinybld_18F4685_10Mhz_19200bds.cof" /x
MPLINK 4.49, Linker
Device Database Version 1.14
Copyright (c) 1998-2011 Microchip Technology Inc.
Errors    : 0

Loaded C:\Mplab8\_Mesprojets_ASM\tinybld_18F4685_10Mhz_19200bds.cof.
----------------------------------------------------------------------
Release build of project `C:\Mplab8\_Mesprojets_ASM\_BOOTLOADERs\Bootloader_18F4685_10Mhz_19200.mcp' succeeded.
Language tool versions: MPASMWIN.exe v5.51, mplink.exe v4.49, mplib.exe v4.49
Sat Mar 19 12:25:31 2016
----------------------------------------------------------------------
BUILD SUCCEEDED